// *****************************************
// *                                       *
// * MBEDIT.CC                             *
// *                                       *
// *                                       *
// * MineBombers level editor              *
// * (C) 1998-1999                         *
// * Yrj Kari-Koskinen, Sampo Lankinen    *
// *                                       *
// * Graphics ripped from MineBombers.     *
// * Sorry guys, but I needed 'em!         *
// *                                       *
// * Uses Allegro programming library 2.2  *
// * by Shawn Hargreaves, 1994/97          *
// *                                       *
// *****************************************

#include <stdio.h>
#include <conio.h>	   // getch
#include <string.h>	   // str*, mem*
#include <ctype.h>	   // tolower, isdigit
#include <bios.h>	   // bioskey, biostime
#include <sys/exceptn.h>   // __djgpp_set_ctrl_c();
#include <go32.h>	   // _go32_want_ctrl_break();
#include <unistd.h>	   // access
#include <math.h>	   // pow2

#include "allegro.h"

// Omat jutskat
#include "mbedit.h"

#include "gifread.c"

#include "screen.cc"
#include "level.cc"
#include "mouse.cc"
#include "misc.cc"


// * * * * * * * * * * * * * * * * * * * * *
//
// * main function                         *
//
// * * * * * * * * * * * * * * * * * * * * *

int main(int argc, char	*argv[]) {

  int x	= 0, y = 0, c = 0, i = 0, j = 0, old_palikka = 100, tempkey = 0,
      alt_pressed = 0, alt_pressed_old = 1,
      palikka =	0, mrk = 0, x2 = 0, y2 = 0, x3 = 0, y3 = 0,
      level_saved = 1, shot_num	= 0, add_x = 0, add_y = 0,
      refresh =	0, x_old = 0, y_old = 0;

  char levelfn[15], name[30], pos[30], tkalu_old = 0,
       undo_level = 0, mouse_b_old = 0, mouse_b_now = 0,
       shot_buf[25], tmp[15], redo_level = 0;

  unsigned char	level[LEVEL_SIZE], tempchar, tool1 = 24, tool2 = 0,
		**undo_buf, temptool = 0;

  _entity      ents[MAX_ENTS+1];
  _square_tool sq;
  sq.begun     = 0;
  _cfg	       cfg;

  RGB palette[256];
  FILE *in;

  BITMAP *kalut[5], *temp_bm = 0, *help;

// read arguments
  if(argc > 1) {
    strncpy(levelfn, argv[1], 14);
    strlwr(levelfn);
    if(!strcmp(levelfn,	"-?") || !strcmp(levelfn, "-h")) {
      printf("MBEDIT <level[.mne]>\n");
      printf("%s\n", ver);
      return 1;
    }
    if(strstr(levelfn, ".mne") == 0 && strstr(levelfn, ".mnl") == 0)
      strcat(levelfn, ".mne");

    // luetaan taso
    if(	(i = lue_leveli(levelfn, level)) != 0) {
      printf("Error reading level \'%s\'!\n", levelfn);
      i	+=  5;
      return i;
    }
  }
  else {
    strcpy(levelfn, "\0");
    tee_tyhja_leveli(level);
  }


// luetaan cfg-tiedosto
  if(lue_cfg(&cfg)) {
    printf("Error reading file \'mbedit.cfg\'!"
                                           " Using default configuration.\n");
    printf("Press any key to continue...\n");
    getch();
  }

// varataan undo-bufferille muisti
  undo_buf = new unsigned char *[cfg.undo_max];
  if(undo_buf == NULL) {
    printf("Not enough memory for the undo buffer!\n");
    return 2;
  }
  for(i	= 0; i < cfg.undo_max; i++) {
    undo_buf[i]	= new unsigned char [LEVEL_SIZE];
    if(undo_buf[i] == NULL) {
      printf("Not enough memory for the undo buffer!\n");
      return 3;
    }
  }

// randomille siement
  srandom(int( biostime(0, 0) ));

// luetaan spritet
  if( (i = lue_graffat(ents)) !=  0) {
    printf("Error reading file \'palette.dat\'!\n");
    i +=  10;
    return i;
  }

// luodaan paletti
  for(c	= 0; c < 255; c++)
    if(c < 16) {
      palette[c].r = pal16[3*c];
      palette[c].g = pal16[3*c+1];
      palette[c].b = pal16[3*c+2];
      }
    else
      palette[c].r = palette[c].g = palette[c].b = 0;
  palette[253].r = palette[253].g = palette[253].b = 48; // mouse color
  palette[255].r = palette[255].g = palette[255].b = 63; // mouse color

// luodaan translation table 2
  for(i	= 0; i < 256; i++)
    ttbl2[ ttbl[i] ] = i;
  ttbl2[100] = 183;

// allegro astuu kehiin eli init varaa muistit ja asettaa muuttujat
  allegro_init();

// hiiri ja taimeri hiirikursoria varten
  if( (i = install_mouse()) < 2)
    if(i == 1) {
      printf("Isn't that one-button mouse quite pathetic?\n");
      return 31;
    }
    else {
      printf("Mouse not found!\n");
      return 32;
    }

// luetaan kursorit fileest BITMAP-structiin
  in = fopen("cursors.dat", "rb");
  if(in	== NULL) {
    printf("Error reading file \'cursors.dat\'!\n");
    return 40;
  }

  kalut[KALU_BRUSH] = create_bitmap(13,	16);
  for(y	= 0; y < 16; y++)
    for(x = 0; x < 13; x++) {
      tempchar = fgetc(in);
      putpixel(kalut[KALU_BRUSH], x, y,	tempchar);
    }

  kalut[KALU_PIPETTI] =	create_bitmap(17, 17);
  for(y	= 0; y < 17; y++)
    for(x = 0; x < 17; x++) {
      tempchar = fgetc(in);
      putpixel(kalut[KALU_PIPETTI], x, y, tempchar);
    }

  kalut[KALU_FILL] = create_bitmap(22, 26);
  for(y	= 0; y < 26; y++)
    for(x = 0; x < 22; x++) {
      tempchar = fgetc(in);
      putpixel(kalut[KALU_FILL], x, y, tempchar);
    }

  kalut[KALU_SQUARE] = create_bitmap(22, 21);
  for(y	= 0; y < 21; y++)
    for(x = 0; x < 22; x++) {
      tempchar = fgetc(in);
      putpixel(kalut[KALU_SQUARE], x, y, tempchar);
    }

  kalut[KALU_SELECT] = create_bitmap(23, 22);
  for(y	= 0; y < 22; y++)
    for(x = 0; x < 23; x++) {
      tempchar = fgetc(in);
      putpixel(kalut[KALU_SELECT], x, y, tempchar);
    }

  fclose(in);

// testataan onko se logo paikalla...
  if(access("logo.gfx", F_OK)) {
    printf("Error reading file \'logo.gfx\'!\n");
    return 42;
  }

  install_timer();

// Sampon pyynnst
  __djgpp_set_ctrl_c(0);		    // Ctrl-C puis
  _go32_want_ctrl_break(1);		    // Ctrl-Break puis


// asetellaan nytttila
  if( (i = set_gfx_mode(GFX_AUTODETECT,	640, 480, 0, 0)) < 0) {
    printf("Error setting up graphics mode 640x480!\n%s\n", allegro_error);
    i +=  50;
    return i;
  }

  if(cfg.show_logo)
    nayta_logo();

  set_palette(black_palette);
  piirra_kehykset(ents);
  piirra_leveli(ents, level);
  fade_in(palette, 3);
  set_palette(palette);

  set_mouse_range(0, 0,	630, 480);
  position_mouse(315, 240);
  text_mode(-1);     // transparent text

// tehdn helpit valmiiks
  help = create_bitmap(HELP_W, HELP_H);
  create_help(help);

// brush-kursori
  set_kalu(KALU_BRUSH, kalut);

// tehdn tyhjleveli undo_bufferiin redoota varten
  memcpy(undo_buf[undo_level], level, LEVEL_SIZE);

// pluuppi:
  while(mrk != -274) {

    if(refresh > 0) {
      if(refresh == 3) { // refreshataan ruutu vlittmsti
	rectfill(screen, 281, 6, 623, 38, 9);
	refresh	= 0;
      }
      if(refresh == 2) { // refreshataan inforuutu kun rotta liikahtaa
	x_old =	x;
	y_old =	y;
	refresh	= 1;
      }			 // varsinainen refresh
      if(x != x_old || y != y_old) {
	rectfill(screen, 281, 6, 623, 38, 9);
	old_palikka = 100;
	refresh	= 0;
      }
    }

// selvitetn miss rotta huitelee ja mik palikka siin on alla
    if(mouse_y > 39) {	// levelin pill
      mouse_on = ON_LEVEL;

      y	= (mouse_y - 36) / 10;
      x	= (mouse_x + 4)	/ 10;
      if(hiirinappi(TYHJA))
	palikka	= ttbl[level[y * 68 + x]];
      else
	if(!alt_pressed	&& (tkalu != KALU_PIPETTI && tkalu != KALU_SELECT)) {
	  if(hiirinappi(VASEN))
	    palikka = tool1;
	  if(hiirinappi(OIKEA))
	    palikka = tool2;
	}
    }
    else {		// toolbarin pill
      mouse_on	= ON_TOOLBAR;
      mouse_on += ON_TEXT;
      palikka	= 100;

      if(mouse_x < 250)	{
	y = (mouse_y - 6) / 11;
	x = (mouse_x - 6) / 11;
	if(y < 3 && x <	22 && mouse_x >	5 && mouse_y > 5) {
	  palikka = toolbar[y][x];
	  mouse_on += ON_PAL;
	  mouse_on -= ON_TEXT;
	}
      }

      if(mouse_x > 254 && mouse_x < 275) {
	if(mouse_y > 9 && mouse_y < 20)	{
	  mouse_on += ON_SELECT;
	  mouse_on -= ON_TEXT;
	  palikka   = tool1;
	}
	if(mouse_y > 24	&& mouse_y < 35) {
	  mouse_on += ON_SELECT;
	  mouse_on -= ON_TEXT;
	  palikka   = tool2;
	}
      }
    }

// piirretn valittu paletin palikka, jos ollaan paletin pll
// tai tehdn pipettiefekti, jos ollaan levelin pll
    if(palikka != 100 && ( (hiiri(ON_PAL) && mouse_b_old == TYHJA) ||
       (hiiri(ON_LEVEL)	&& alt_pressed)	) ) {
      show_mouse(NULL);

      if(hiirinappi(VASEN)) {
	tool1 =	palikka;
	piirra_palikka(screen, ents[palikka].gfx, 25, 1, 5, 0);
	piirra_palikka(screen, ents[palikka].gfx, 26, 1, 5, 0);
      }

      if(hiirinappi(OIKEA)) {
	tool2 =	palikka;
	piirra_palikka(screen, ents[palikka].gfx, 25, 2, 5, 5);
	piirra_palikka(screen, ents[palikka].gfx, 26, 2, 5, 5);
      }

      show_mouse(screen);
      vsync();
    }

// pipetti kursoriks jos ollaan paletin pll tai alt pohjassa
    if((hiiri(ON_PAL) && (mouse_on_old & ON_PAL) == 0) ||
       (alt_pressed && !alt_pressed_old) && hiirinappi(TYHJA)) {
      tkalu_old	= tkalu;
      set_kalu(KALU_PIPETTI, kalut);
    }

// jos ei, niin normaali takas
    if((!hiiri(ON_PAL) && (mouse_on_old	& ON_PAL) == ON_PAL) ||
       (!alt_pressed &&	alt_pressed_old) && hiirinappi(TYHJA))
      set_kalu(tkalu_old, kalut);


    // levelin pill & o tai v hiirinappi painettu -> kytetn tykaluja
    if(x > 0 &&	x < 63 && y > 0	&& y < 44 && !hiirinappi(TYHJA)	&&
       hiiri(ON_LEVEL) && !alt_pressed && !hiirinappi(KESKI)) {

      if(tkalu == KALU_PIPETTI)	{
	show_mouse(NULL);

	if(hiirinappi(VASEN)) {
	  tool1	= palikka;
	  piirra_palikka(screen, ents[palikka].gfx, 25,	1, 5, 0);
	  piirra_palikka(screen, ents[palikka].gfx, 26,	1, 5, 0);
	}

	if(hiirinappi(OIKEA)) {
	  tool2	= palikka;
	  piirra_palikka(screen, ents[palikka].gfx, 25,	2, 5, 5);
	  piirra_palikka(screen, ents[palikka].gfx, 26,	2, 5, 5);
	}

	show_mouse(screen);
	vsync();
      }
      else {

// hiiren nappi ei edellisell kerralla pohjassa
	show_mouse(NULL);
	switch(tkalu) {
	  case KALU_BRUSH:
	    if(hiirinappi(VASEN))
	      temptool = tool1;

	    if(hiirinappi(OIKEA))
	      temptool = tool2;

	    level[y * 68 + x] =	ttbl2[temptool];
	    piirra_palikka(screen, ents[temptool].gfx, x, y, -5, 35);
	    break;

	  case KALU_FILL:
	    if(hiirinappi(VASEN))
	      make_fill(x, y, tool1, level, ents);

	    if(hiirinappi(OIKEA))
	      make_fill(x, y, tool2, level, ents);

	    piirra_leveli(ents,	level);
	    break;

	  case KALU_SQUARE:
	     if(sq.begun == 0) {
	       sq.oldx = x;
	       sq.oldy = y;
	       sq.begun	= 1;

	       if(hiirinappi(VASEN))
		 sq.tool = tool1;

	       if(hiirinappi(OIKEA))
		 sq.tool = tool2;

	       temp_bm = create_bitmap(620, 430);
	       clear(temp_bm);
	       blit(screen, temp_bm, 5,	45, 0, 0, 620, 430);

	     }
	     else if(sq.curx !=	x || sq.cury !=	y) {
	       sq.curx = x;
	       sq.cury = y;

	       if(sq.begun == 2) {
		 undo_line(temp_bm, x2,	y2, x2,	y3);
		 undo_line(temp_bm, x2,	y2, x3,	y2);
		 undo_line(temp_bm, x3,	y3, x3,	y2);
		 undo_line(temp_bm, x3,	y3, x2,	y3);
	       }

	       if(sq.oldx <=  sq.curx && sq.oldy <=  sq.cury) {
		 x2 = sq.oldx *	10 - 5;
		 y2 = sq.oldy *	10 + 35;
		 x3 = sq.curx *	10 + 4;
		 y3 = sq.cury *	10 + 44;
	       }
	       if((sq.oldx > sq.curx &&	sq.oldy	>=  sq.cury) ||
		  (sq.oldx == sq.curx && sq.oldy > sq.cury)) {
		 x2 = sq.curx *	10 - 5;
		 y2 = sq.cury *	10 + 35;
		 x3 = sq.oldx *	10 + 4;
		 y3 = sq.oldy *	10 + 44;
	       }
	       if(sq.oldx < sq.curx && sq.oldy > sq.cury) {
		 x2 = sq.oldx *	10 - 5;
		 y2 = sq.oldy *	10 + 44;
		 x3 = sq.curx *	10 + 4;
		 y3 = sq.cury *	10 + 35;
	       }
	       if(sq.oldx > sq.curx && sq.oldy < sq.cury) {
		 x2 = sq.curx *	10 - 5;
		 y2 = sq.cury *	10 + 44;
		 x3 = sq.oldx *	10 + 4;
		 y3 = sq.oldy *	10 + 35;
	       }

	       line(screen, x2,	y2, x2,	y3, 9);
	       line(screen, x2,	y2, x3,	y2, 9);
	       line(screen, x3,	y3, x2,	y3, 9);
	       line(screen, x3,	y3, x3,	y2, 9);
	       if(sq.begun == 1) sq.begun = 2;
	     }
	     break;
	}

	show_mouse(screen);
	vsync();
      }
    }


    // levelin pill & o tai v hiirinappi pstetty yls
    if(x > 0 &&	x < 63 && y > 0	&& y < 44 && hiirinappi(TYHJA) &&
       hiiri(ON_LEVEL) && mouse_b_old != TYHJA)	{

      show_mouse(NULL);
      switch(tkalu) {
	case KALU_SQUARE:
	   if(sq.begun > 0) {
	     sq.begun =	0;
	     destroy_bitmap(temp_bm);

	     if(sq.oldx	< sq.curx) {
	       if(sq.oldy < sq.cury)
		 for(x2	= sq.oldx; x2 <	(sq.curx+1); x2++)
		   for(y2 = sq.oldy; y2	< (sq.cury+1); y2++)
		     level[y2 *	68 + x2] = ttbl2[randomize(sq.tool)];

	       if(sq.oldy > sq.cury)
		 for(x2	= sq.oldx; x2 <	(sq.curx+1); x2++)
		   for(y2 = sq.cury; y2	< (sq.oldy+1); y2++)
		     level[y2 *	68 + x2] = ttbl2[randomize(sq.tool)];

	       if(sq.oldy == sq.cury)
		 for(x2	= sq.oldx; x2 <	(sq.curx+1); x2++)
		   level[sq.cury * 68 +	x2] = ttbl2[randomize(sq.tool)];
	     }

	     if(sq.oldx	> sq.curx) {
	       if(sq.oldy < sq.cury)
		 for(x2	= sq.curx; x2 <	(sq.oldx+1); x2++)
		   for(y2 = sq.oldy; y2	< (sq.cury+1); y2++)
		     level[y2 *	68 + x2] = ttbl2[randomize(sq.tool)];

	       if(sq.oldy > sq.cury)
		 for(x2	= sq.curx; x2 <	(sq.oldx+1); x2++)
		   for(y2 = sq.cury; y2	< (sq.oldy+1); y2++)
		     level[y2 *	68 + x2] = ttbl2[randomize(sq.tool)];

	       if(sq.oldy == sq.cury)
		 for(x2	= sq.curx; x2 <	(sq.oldx+1); x2++)
		   level[sq.cury * 68 +	x2] = ttbl2[randomize(sq.tool)];
	     }

	     if(sq.oldx	== sq.curx) {
	       if(sq.oldy < sq.cury)
		 for(y2	= sq.oldy; y2 <	(sq.cury+1); y2++)
		   level[y2 * 68 + sq.curx] = ttbl2[randomize(sq.tool)];

	       if(sq.oldy > sq.cury)
		 for(y2	= sq.cury; y2 <	(sq.oldy+1); y2++)
		   level[y2 * 68 + sq.curx] = ttbl2[randomize(sq.tool)];

	       if(sq.oldy == sq.cury)
		 level[sq.cury * 68 + sq.curx] = ttbl2[randomize(sq.tool)];
	     }

	     piirra_leveli(ents, level);
	   }
	   break;
      }
      show_mouse(screen);
    }

//    level_changed = memcmp(undo_buf[undo_level], level, LEVEL_SIZE);

    // tehdn undoot bufferiin, jos ollaan levelin pll, ei tehd mitn
    // ja taso on muuttunut sitten edellisen undoon
    if(x > 0 &&	x < 63 && y > 0	&& y < 44 && hiirinappi(TYHJA) &&
       hiiri(ON_LEVEL) && memcmp(undo_buf[undo_level], level, LEVEL_SIZE)) {

      if(undo_level == (cfg.undo_max-1)) {
        // siirretn aikasempia kumottuja taaksepin
        for(i = 1; i < cfg.undo_max; i++)
          memcpy(undo_buf[i - 1], undo_buf[i], LEVEL_SIZE);
        memcpy(undo_buf[undo_level], level, LEVEL_SIZE);
      }
      if(undo_level < (cfg.undo_max-1) && undo_level > -1) {
        undo_level++;
        memcpy(undo_buf[undo_level], level, LEVEL_SIZE);
      }
      level_saved = 0;
      redo_level = 0;
    }

    // levelin pill tahi toolbarin pill, piirretn teksti
    if(cfg.tekstit)
      if(x < 64	&& y >=	0 && y < 45 && !hiiri(ON_TEXT))	{
	if(y < 3)
	  show_mouse(NULL);
	else
	  freeze_mouse_flag = 1;

	if(hiiri(ON_LEVEL) && cfg.pos_text) {  // levelin pill
	  rectfill(screen, 445,	6, 623,	16, 9);
	  sprintf(pos, "Pos: %02d,%02d", x+1, y+1);
	  textout(screen, font,	pos, 446, 9, 0);
	}

	if(palikka != old_palikka && cfg.palikka_text) {
	  rectfill(screen, 281,	6, 623,	38, 9);
	  sprintf(name,	"Name: %s", ents[palikka].name);

	  textout(screen, font,	name, 286, 9, 0);
	  textout(screen, font,	ents[palikka].text, 286, 19, 0);

	  if(ents[palikka].text2[0] != '\0')  // jos meill on lis teksti
	    textout(screen, font, ents[palikka].text2, 286, 29,	0);
	}
	if(!cfg.palikka_text) {
	  rectfill(screen, 281,	6, 444,	16, 9);
	  if(levelfn[0]	== '\0')
	    sprintf(name, "Name: <untitled>");
	  else
	    sprintf(name, "Name: %s", levelfn);
	  textout(screen, font,	name, 286, 9, 0);
	}

	if(y < 3)
	  show_mouse(screen);
	else
	  freeze_mouse_flag = 0;

	vsync();
      }
      else
	if((mouse_on_old & ON_TEXT) != ON_TEXT)	{
	  show_mouse(NULL);
	  rectfill(screen, 281,	6, 623,	38, 9);
	  show_mouse(screen);
	  vsync();
	}

    old_palikka	 = palikka;
    mouse_on_old = mouse_on;
    mouse_b_old	 = mouse_b_now;
    mouse_b_now	 = mouse_b;

    tempkey = bioskey(2);
    alt_pressed_old = alt_pressed;
    alt_pressed	= (tempkey & 8)	>> 3;
/*        1
          2631
          8426 8421

          7654 3210  Meaning
          
          ---- ---X  Right shift key down
          ---- --X-  Left shift key down
          ---- -X--  Ctrl key down
          ---- X---  Alt key down
          ---X ----  Scroll lock on
          --X- ----  Num lock on
          -X-- ----  Caps lock on
          X--- ----  Insert on */


    if(kbhit() && hiirinappi(TYHJA)) {
      mrk = getch();
      if(mrk ==	0) mrk = -getch();

// kahtotaan nit nppimi.
      switch(mrk) {
	 case K_F5:
		set_kalu(KALU_PIPETTI, kalut);
		break;

	 case K_F6:
		set_kalu(KALU_BRUSH, kalut);
		break;

	 case K_F7:
		set_kalu(KALU_FILL, kalut);
		break;

	 case K_F8:
		set_kalu(KALU_SQUARE, kalut);
		break;

	 case K_F9:
		set_kalu(KALU_SELECT, kalut);
		break;

	 case K_CTRL_P:
		do {  // kasvatetaan shotin numeroa kunnes sellaista ei ole
		  if(++shot_num	> 9999)	 // jo olemassa (hoono soomi)
		    shot_num = 1;
		  sprintf(shot_buf, "shot%04d.pcx", shot_num);
		}
		while(!access(shot_buf,	F_OK));

		if(hiirinappi(TYHJA)) {
		  if(!cfg.mouse_in_shot)
		    show_mouse(NULL);
		  if(cfg.level_shot)
		    temp_bm = create_sub_bitmap(screen,	0, 40, 630, 440);
		  else
		    temp_bm = create_sub_bitmap(screen,	0, 0, 630, 480);
		  save_bitmap(shot_buf,	temp_bm, palette);
		  show_mouse(screen);
		  destroy_bitmap(temp_bm);
		}
		sprintf(shot_buf, "'shot%04d.pcx' saved", shot_num);
		rectfill(screen, 281, 6, 623, 38, 9);
		textout(screen,	font, shot_buf,	286, 19, 0);
		refresh	= 2;
		break;

	 case K_CTRL_Z:	      // Undo
		if(undo_level >	0) {
                  undo_level--;
		  memcpy(level,	undo_buf[undo_level], LEVEL_SIZE);
		  show_mouse(NULL);
		  piirra_leveli(ents, level);
		  show_mouse(screen);

                  redo_level++;
		}
		break;

         case K_CTRL_z:       // Redo
                if(redo_level > 0) {
                  undo_level++;
		  memcpy(level,	undo_buf[undo_level], LEVEL_SIZE);
		  show_mouse(NULL);
		  piirra_leveli(ents, level);
		  show_mouse(screen);

                  redo_level--;
                }
                break;

	 case K_CTRL_R:	      // levelin refresh
		show_mouse(NULL);
		set_palette(palette);
		piirra_kehykset(ents);
		piirra_leveli(ents, level);
		show_mouse(screen);
		old_palikka = 100;
		break;

// jos joku valop haluaa testata leveliin kirjoitusta...
	 case K_F2:
	 case K_CTRL_S:
		level_saved = kirjota_leveli(levelfn, level, level_saved);
		refresh	= 2;
		break;

	 case K_CTRL_A:		// Save As
		strcpy(tmp, levelfn);
		levelfn[0] = '\0';
		level_saved = kirjota_leveli(levelfn, level, level_saved);
		if(level_saved == 0) {
		  strcpy(levelfn, tmp);
		  refresh = 2;	// delayed refresh
		}
		else
		  refresh = 3;	// immediate refresh
		break;

	 case K_ALT_X:		// Quick quit
		mrk = -274;
		break;

	 case K_ESC:
	 case K_CTRL_Q:	       // Normal quit
		mrk = quit(level_saved,	levelfn, level);
		old_palikka = 100;
		break;

	 case K_CTRL_T:	       // Toggle texts on/off
		cfg.tekstit = (cfg.tekstit == 1	? 0 : 1);
		if(!cfg.tekstit)
		  rectfill(screen, 281,	6, 623,	38, 9);
		old_palikka = 100;
		break;

	 case K_CTRL_O:	       // Toggle position info on/off
		cfg.pos_text = (cfg.pos_text ==	1 ? 0 :	1);
		if(!cfg.pos_text)
		  rectfill(screen, 445,	6, 623,	16, 9);
		break;

	 case K_CTRL_N:	       // Toggle palikka/level info
		cfg.palikka_text = (cfg.palikka_text ==	1 ? 0 :	1);
		if(!cfg.palikka_text)
		  rectfill(screen, 281,	6, 623,	38, 9);
		old_palikka = 100;
		break;

	 case K_F3:
	 case K_CTRL_L:	       // Load
		rectfill(screen, 281, 19, 623, 38, 9);
		if(level_saved == 0) {
		  textout(screen, font,	"Load: Continue (Yes/No)",
                          286, 19, 0);
		  textout(screen, font,	"Changes have not been saved!",
	                  286, 29, 3);
		  if( (getch_until("yn")) != 'y') {
		    refresh = 3;
		    break;
		  }
		}

		rectfill(screen, 281, 19, 623, 38, 9);
		strcpy(tmp, levelfn); // pistetn nykysen levelin nimi
				      // muistiin kosahduksen varalle
		kysy_nimi(levelfn, LOAD);
		if(levelfn[0] == '\0') {
		  strcpy(levelfn, tmp);
		  refresh = 3;
		  break;
		}

		// Let's make a copy of current level to undo buffer
		memcpy(undo_buf[0], level, LEVEL_SIZE);
		undo_level = 0;

		if(lue_leveli(levelfn, level) >	0) {
		  textout(screen, font,	"Load error!", 286, 29,	3);
		  memcpy(level,	undo_buf[0], LEVEL_SIZE);
		  strcpy(levelfn, tmp);
		}
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
		if(!cfg.palikka_text ||	!cfg.tekstit)
		  refresh = 3;
		else
		  old_palikka =	100;

		// Let's make a copy of current level to undo buffer
		undo_level = 0;
		memcpy(undo_buf[undo_level], level, LEVEL_SIZE);
		level_saved = 1;
                redo_level = 0;
		break;

	 case K_F1:	       // Help
                show_mouse(NULL);
		temp_bm = create_bitmap(HELP_W, HELP_H);
		blit(screen, temp_bm,	(630 - HELP_W) / 2,
                     (520 - HELP_H) / 2, 0, 0, HELP_W, HELP_H);
		blit(help, screen, 0,	0, (630	- HELP_W) / 2,
                     (520 - HELP_H) / 2, HELP_W, HELP_H);
		getch();

		blit(temp_bm,	screen,	0, 0, (630 - HELP_W) / 2,
                     (520 - HELP_H) / 2, HELP_W, HELP_H);
		destroy_bitmap(temp_bm);
		show_mouse(screen);
                break;

	 case K_F12:	       // Clear level
		strcpy(levelfn,	"\0");
		tee_tyhja_leveli(level);
		show_mouse(NULL);
		set_palette(palette);
		piirra_kehykset(ents);
		piirra_leveli(ents, level);
		show_mouse(screen);

		old_palikka = 100;
		level_saved = 1;
		undo_level  = 0;
                redo_level  = 0;
		// Let's make a copy of current level to undo buffer
		memcpy(undo_buf[undo_level], level, LEVEL_SIZE);
		break;

         case K_F4:            // Add random stuff
         case K_CTRL_F4:
                add_x = random() % 62 + 1;
                add_y = random() % 43 + 1;
                level[add_y*68+add_x] = ttbl2[(mrk == K_F4 ? tool1 : tool2)];
                piirra_palikka(screen, ents[mrk == K_F4 ? tool1 : tool2].gfx,
                               add_x - 1, add_y + 3, 5, 5);
                level_saved = 0;
                break;

         case K_CTRL_LEFT:     // Mirror right to left
                for(i = 1; i < 44; i++)
                  for(j = 1; j < 32; j++)
                    level[i * 68 + j] = level[i * 68 + (63 - j)];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_RIGHT:    // Mirror left to right
                for(i = 1; i < 44; i++)
                  for(j = 1; j < 32; j++)
                    level[i * 68 + (63 - j)] = level[i * 68 + j];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_UP:       // Mirror down to up
                for(i = 1; i < 22; i++)
                  for(j = 1; j < 63; j++)
                    level[i * 68 + j] = level[(44 - i) * 68 + j];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_DOWN:     // Mirror up to down
                for(i = 1; i < 22; i++)
                  for(j = 1; j < 63; j++)
                    level[(44 - i) * 68 + j] = level[i * 68 + j];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_HOME:     // Flip'n mirror right to left
                for(i = 1; i < 44; i++)
                  for(j = 1; j < 32; j++)
                    level[(44 - i) * 68 + j] = level[i * 68 + (63 - j)];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_END:      // Flip'n mirror up to down
                for(i = 1; i < 22; i++)
                  for(j = 1; j < 63; j++)
                    level[(44 - i) * 68 + (63 - j)] = level[i * 68 + j];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_PGDN:     // Flip'n mirror left to right
                for(i = 1; i < 44; i++)
                  for(j = 1; j < 32; j++)
                    level[(44 - i) * 68 + (63 - j)] = level[i * 68 + j];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

         case K_CTRL_PGUP:     // Flip'n mirror down to up
                for(i = 1; i < 22; i++)
                  for(j = 1; j < 63; j++)
                    level[i * 68 + (63 - j)] = level[(44 - i) * 68 + j];
		show_mouse(NULL);
		piirra_leveli(ents, level);
		show_mouse(screen);
                break;

      }	// switch
    } // if
//    if(hiirinappi(KESKI))
//      mine_sweep(555, level, ents);
  } // while


  __djgpp_set_ctrl_c(1);		    // Ctrl-C takas
  _go32_want_ctrl_break(0);		    // Ctrl-Break takas

  destroy_bitmap(help);                     // helpin bitmap
  for(i	= 0; i < 5; i++)                    // kalut pois
    destroy_bitmap(kalut[i]);

  for(i	= 0; i < cfg.undo_max; i++)         // undoot vapaaks
     delete [] undo_buf[i];
  delete [] undo_buf;

  fade_out(3);

// atexit-funktiot: allegro_exit, remove_mouse, remove_timer
  return 0;
}
