// *****************************************
// *                                       *
// * SCREEN.CC                             *
// *                                       *
// * Screen write functions                *
// *                                       *
// * MineBombers level editor              *
// * (C) 1998-1999                         *
// * Yrj Kari-Koskinen, Sampo Lankinen    *
// *                                       *
// *****************************************


// Piirt pienet metallipalikat ja harmaat 3D-systeemit
void piirra_kehykset(const _entity *ents) {

  int x, y, x2, y2, c;
  BITMAP *buffer = create_bitmap(SCREEN_W, SCREEN_H);
  clear(buffer);

// taustavri harmaa
  rectfill(buffer, 5, 5, 629, 39, 9);

// tumman- ja vaaleanharmaat reunat (3D-efekti)
  // pysty
  vline(buffer, 5, 6, 39, 10);      // tumma
  vline(buffer, 280, 6, 39, 10);
  vline(buffer, 249, 5, 38, 8);     // vaalea
  vline(buffer, 624, 5, 38, 8);

  // vaaka
  hline(buffer, 5, 39, 248, 10);    // tumma
  hline(buffer, 280, 39, 623, 10);
  hline(buffer, 6, 5, 249, 8);      // vaalea
  hline(buffer, 281, 5, 624, 8);

// pikkulaatat pystysuoraan
  for(y = 0; y < 96; y++)
    for(y2 = 0; y2 < 5; y2++)
      for(x2 = 0; x2 < 5; x2++) {
        c = y2 * 5 + x2;
        _putpixel(buffer, x2, y * 5 + y2, pikkulaatta[c]);
        _putpixel(buffer, x2 + 625, y * 5 + y2, pikkulaatta[c]);
      }

// pikkulaatat vaakasuoraan
  for(x = 1; x < 125; x++)
    for(y2 = 0; y2 < 5; y2++)
      for(x2 = 0; x2 < 5; x2++) {
        c = y2 * 5 + x2;
        _putpixel(buffer, x2 + x * 5, y2, pikkulaatta[c]);
        _putpixel(buffer, x2 + x * 5, 40 + y2, pikkulaatta[c]);
        _putpixel(buffer, x2 + x * 5, 475 + y2, pikkulaatta[c]);
      }

// tykalut
  for(x = 0; x < 22; x++)
    for(y = 0; y < 3; y++)
      piirra_palikka(buffer, ents[ toolbar[y][x] ].gfx, x, y, x + 7, y + 7);


// valittu paletista
  for(y = 1; y < 8; y++)
    for(y2 = 0; y2 < 5; y2++)
      for(x2 = 0; x2 < 5; x2++) {
        c = y2 * 5 + x2;
        _putpixel(buffer, x2 + 250, y * 5 + y2, pikkulaatta[c]);
        _putpixel(buffer, x2 + 275, y * 5 + y2, pikkulaatta[c]);
      }

  for(x = 50; x < 56; x++)
    for(y2 = 0; y2 < 5; y2++)
      for(x2 = 0; x2 < 5; x2++) {
        c = y2 * 5 + x2;
        _putpixel(buffer, x2 + x * 5, y2 + 5, pikkulaatta[c]);
        _putpixel(buffer, x2 + x * 5, y2 + 20, pikkulaatta[c]);
        _putpixel(buffer, x2 + x * 5, y2 + 35, pikkulaatta[c]);
      }

  piirra_palikka(buffer, ents[24].gfx, 25, 1, 5, 0);
  piirra_palikka(buffer, ents[24].gfx, 26, 1, 5, 0);

  piirra_palikka(buffer, ents[0].gfx, 25, 2, 5, 5);
  piirra_palikka(buffer, ents[0].gfx, 26, 2, 5, 5);

// tyhj (tunnel) tausta leveliin
  for(y = 1; y < 44; y++)
    for(x = 1; x < 63; x++)
      piirra_palikka(buffer, ents[0].gfx, x - 1, y + 3, 5, 5);

  blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
  destroy_bitmap(buffer);

  vsync();
  return;
}



// Piirt 'level':st lytyvill palikoilla taulun nytlle
void piirra_leveli(const _entity *ents, unsigned char *level) {
  int x,y;
  BITMAP *buffer = create_bitmap(620, 430);
  clear(buffer);

  for(y = 1; y < 44; y++)
    for(x = 1; x < 63; x++)
        piirra_palikka(buffer, ents[ ttbl[ level[y * 68 + x] ] ].gfx,
                     x - 1, y - 1, 0, 0);

  blit(buffer, screen, 0, 0, 5, 45, 620, 430);
  destroy_bitmap(buffer);

  vsync();
  return;
}



// Piirt 'p':st lytyvt 10x10 pixeli 'bmap':iin kohtaan
void piirra_palikka(BITMAP *bmap, const char *p, const int px, const int py,
                    const int xadd, const int yadd) {
  int x, y, y2 = py*10 + yadd, x2 = px*10 + xadd;

  for(y = y2; y < (y2+10); y++)
    for(x = x2; x < (x2+10); x++)
      _putpixel(bmap, x, y, p[(y-y2)*10 + (x-x2)]);

  return;
}



// Heitt logon nytlle
void nayta_logo(void) {

  BITMAP *logo;
  RGB    pal[256];
  char   *buffer;
  int    x, y, x_size, y_size;

  // Ensin luetaan x_size ja y_size
  if(GIF_read("logo.gfx", NULL, pal, &x_size, &y_size) > 9)
    return;

  buffer = new char [x_size * y_size];
  if(buffer == NULL)
    return;

  // Nyt luetaan sitte loput.
  GIF_read("logo.gfx", buffer, NULL, NULL, NULL);

  logo = create_bitmap(x_size, y_size);

  for(y = 0; y < y_size; y++)
    for(x = 0; x < x_size; x++)
      _putpixel(logo, x, y, buffer[y * x_size + x]);

  delete [] buffer;

  set_palette(pal);
  blit(logo, screen, 0, 0, (640 - x_size) / 2, (480 - y_size) / 2,
       x_size, y_size);
  vsync();

  delay(3000);
  fade_out(3);

//clear_to_color(logo, 0);
//blit(logo, screen, 0, 0, 0, 0, 640, 480);
  vsync();

  destroy_bitmap(logo);

  return;
}



// Luo helpit 'help':iin
void create_help(BITMAP *help) {

  int y, y2, x, x2, c;

  clear_to_color(help, 0);
  rectfill(help, 6, 6, HELP_W - 7, HELP_H - 7, 9);

// tumman- ja vaaleanharmaat reunat (3D-efekti)
  // pysty             x   y           y   c
  vline(help,          5,  5,         29, 10);
  vline(help,          5, 35, HELP_H - 6, 10);
  vline(help, HELP_W - 6,  5,         29,  8);
  vline(help, HELP_W - 6, 35, HELP_H - 6,  8);

  // vaaka      x           y           x   c
  hline(help,   6,          5, HELP_W - 6,  8);
  hline(help,   6,         35, HELP_W - 6,  8);
  hline(help,   6,         29, HELP_W - 6, 10);
  hline(help,   6, HELP_H - 6, HELP_W - 6, 10);

  _putpixel(help,          5,          5, 9);
  _putpixel(help, HELP_W - 6,         29, 9);
  _putpixel(help,          5,         35, 9);
  _putpixel(help, HELP_W - 6, HELP_H - 6, 9);

// pikkulaatat pystysuoraan
  for(y = 0; y < HELP_H / 5; y++)
    for(y2 = 0; y2 < 5; y2++)
      for(x2 = 0; x2 < 5; x2++) {
        c = y2 * 5 + x2;
        _putpixel(help, x2, y * 5 + y2, pikkulaatta[c]);
        _putpixel(help, x2 + HELP_W - 5, y * 5 + y2, pikkulaatta[c]);
      }

// pikkulaatat vaakasuoraan
  for(x = 1; x < HELP_W / 5 - 1; x++)
    for(y2 = 0; y2 < 5; y2++)
      for(x2 = 0; x2 < 5; x2++) {
        c = y2 * 5 + x2;
        _putpixel(help, x2 + x * 5, y2, pikkulaatta[c]);
        _putpixel(help, x2 + x * 5, 30 + y2, pikkulaatta[c]);
        _putpixel(help, x2 + x * 5, HELP_H - 5 + y2, pikkulaatta[c]);
      }

  textout(help, font, "* ------ * ------ *  Help  * ------ * ------ *",
                                                  11,  14, 0);
  textout(help, font, "F1           Help",        25,  45, 0);

  textout(help, font, "F5           Pipette",     25,  60, 0);
  textout(help, font, "F6           Brush",       25,  70, 0);
  textout(help, font, "F7           Fill",        25,  80, 0);
  textout(help, font, "F8           Square",      25,  90, 0);
  textout(help, font, "F9           Select (not yet functional)",
                                                  25, 100, 0);

  textout(help, font, "F4           Add tool1 randomly",
                                                  25, 115, 0);
  textout(help, font, "CTRL-F4      Add tool2 randomly",
                                                  25, 125, 0);

  textout(help, font, "CTRL-LEFT    Mirror right to left",
                                                  25, 140, 0);
  textout(help, font, "CTRL-RIGHT   Mirror left to right",
                                                  25, 150, 0);
  textout(help, font, "CTRL-UP      Mirror down to up",
                                                  25, 160, 0);
  textout(help, font, "CTRL-DOWN    Mirror up to down",
                                                  25, 170, 0);
  textout(help, font, "CTRL-HOME    Flip and mirror right to left",
                                                  25, 180, 0);
  textout(help, font, "CTRL-PGDN    Flip and mirror left to right",
                                                  25, 190, 0);
  textout(help, font, "CTRL-PGUP    Flip and mirror down to up",
                                                  25, 200, 0);
  textout(help, font, "CTRL-END     Flip and mirror up to down",
                                                  25, 210, 0);

  textout(help, font, "F12          Clear level", 25, 225, 0);

  textout(help, font, "Ctrl-Z       Undo",        25, 240, 0);
  textout(help, font, "Ctrl-<       Redo",        25, 250, 0);

  textout(help, font, "Ctrl-L, F3   Load",        25, 265, 0);
  textout(help, font, "Ctrl-S, F2   Save",        25, 275, 0);
  textout(help, font, "Ctrl-A       Save as",     25, 285, 0);

  textout(help, font, "Ctrl-T       Toggle info texts on/off",
                                                  25, 300, 0);
  textout(help, font, "Ctrl-N       Toggle level name/palikka info",
                                                  25, 310, 0);
  textout(help, font, "Ctrl-O       Toggle cursor position on/off",
                                                  25, 320, 0);

  textout(help, font, "Ctrl-P       Screen shot", 25, 335, 0);
  textout(help, font, "Ctrl-R       Refresh",     25, 345, 0);

  textout(help, font, "Ctrl-Q, Esc  Quit",        25, 360, 0);
  textout(help, font, "Alt-X        Quick quit",  25, 370, 0);

  return;
}



// Piirt nytlle viivan bmp:st luetuilla vreill
void undo_line(BITMAP *bmp, int startx, int starty,
               const int endx, const int endy) {
  register int t, dist;
  int xerr = 0, yerr = 0, dx, dy;
  int incx, incy;

  dx = endx - startx;    // Pisteiden vlimatkat
  dy = endy - starty;
  if(dx > 0) incx = 1;     // X-vlimatkan suunta
    else if(dx == 0) incx = 0;
      else incx = -1;

  if(dy > 0) incy = 1;     // Y-vlimatkan suunta
    else if(dy == 0) incy = 0;
      else incy = -1;

  dx = abs(dx);        // Kumpi on pitempi vlimatka
  dy = abs(dy);
  if(dx > dy) dist = dx;
    else dist = dy;

  for(t = 0; t <=  (dist+1); t++) {
    _putpixel(screen, startx, starty, _getpixel(bmp, startx-5, starty-45));
    xerr +=  dx;
    yerr +=  dy;
    if(xerr > dist) {
      xerr   -=  dist;
      startx +=  incx;
    }
    if(yerr > dist) {
      yerr   -=  dist;
      starty +=  incy;
    }
  }
  return;
}



// Tytt 'x','y' paikasta lhtien 'tool'-entityll 'level':in alueen
int make_fill(const int x, const int y, const int tool,
              unsigned char *level, const _entity *e) {
// fill tykalun rekkursio

  unsigned char temp, alla;

// tarkistetaan reunat
  if(y < 1 || x < 1 || y > 43 || x > 62)
    return 1;

// selvitetn mik alla
  alla = level[y * 68 + x];

// random-jutskat poies
  alla = unrandomize(alla);

  if(alla == ttbl2[tool])
    return 2;

  temp = randomize(tool);
// piirretn current pos
  level[y * 68 + x] = ttbl2[temp];

// oikeelle
  temp = level[y * 68 + x + 1];
  temp = unrandomize(temp);
  if(x < 62 && temp == alla)
    make_fill(x+1, y, tool, level, e);

// alas
  temp = level[(y+1) * 68 + x];
  temp = unrandomize(temp);
  if(y < 43 && temp == alla)
    make_fill(x, y+1, tool, level, e);

// vasemmalle
  temp = level[y * 68 + x - 1];
  temp = unrandomize(temp);
  if(x > 1  && temp == alla)
    make_fill(x-1, y, tool, level, e);

// yls
  temp = level[(y-1) * 68 + x];
  temp = unrandomize(temp);
  if(y > 1  && temp == alla)
    make_fill(x, y-1, tool, level, e);

  return 0;
}
